/*** sex3.t version 1.2 ***/
/* An AIF library for TADS 3 */
/* Copyright 2007 by Sir Gareth */
/* The author would like to thank Newkid, Choices, MMXTads, and */
/* Scarlet Herring, who provided inspiration for parts of this library. */

/*** Basic sex stuff, may want to move to separate library ***/

/* Private rooms */

modify Room
  isPrivate = nil
;

class PrivateRoom: Room
  isPrivate = true
;

modify NestedRoom
  isPrivate { return location.isPrivate; }
;

/* New postures */

kneeling: Posture
    tryMakingPosture(loc) { return tryImplicitAction(KneelOn, loc); }
    setActorToPosture(actor, loc) { nestedActorAction(actor, KneelOn, loc); }
    msgVerbI = 'kneel{s} down'
    msgVerbT = 'kneel{s}'
    participle = 'kneeling'
;

modify BasicBed
    replace allowedPostures = [sitting, lying, standing, kneeling]
    replace obviousPostures = [sitting, lying, kneeling]
    dobjFor(KneelOn)
    {
        preCond = (preCondForEntry(kneeling))
        verify()
        {
            /* verify entering the chair in a 'kneeling' posture */
            if (verifyEntry(kneeling, &alreadySittingOnMsg, &noRoomToSitMsg))
                inherited();
        }
        action()
        {
            /* enter the chair in the 'sitting' posture */
            performEntry(kneeling);
        }
    }
;

modify Floor
    replace hideFromDefault(action)
    {
        /* don't hide from STAND ON, SIT ON, LIE ON */
        if (action.ofKind(StandOnAction)
            || action.ofKind(SitOnAction)
            || action.ofKind(LieOnAction)
            || action.ofKind(KneelOnAction))
            return nil;

        /* for other actions, use the standard handling */
        return inherited(action);
    }
    dobjFor(KneelOn)
    {
        preCond = [touchObj,
                   new ObjectPreCondition(gActor.location.getOutermostRoom(),
                                          actorDirectlyInRoom)]
        verify() { verifyEntry(kneeling, &alreadySittingOnMsg); }
        action() { performEntry(kneeling); }
    }
;

modify NestedRoomFloor
    dobjFor(KneelOn) remapTo(KneelOn, location)
;

modify NominalPlatform
    dobjFor(KneelOn) { verify() { illogical(&cannotSitOnMsg); } }
;

/* sex verbs */

DefineIAction(Dance)
  execAction() { mainReport('{You/he} dance{s} a little jig. '); }
;

VerbRule(Dance)
  'dance'
  : DanceAction
  verbPhrase = 'dance/dancing'
;

DefineTAction(DanceWith);

VerbRule(DanceWith)
  ( 'dance' 'with' ) singleDobj
  : DanceWithAction
  verbPhrase = 'dance/dancing (what)'
;

DefineTAction(KneelOn);

VerbRule(KneelOn)
    'kneel' ('on' | 'in' | 'down' 'on' | 'down' 'in')
        singleDobj
    : KneelOnAction
    verbPhrase = 'kneel/kneeling (on what)'
    askDobjResponseProd = singleNoun
;

VerbRule(KneelOnWhat)
    [badness 500] 'kneel' ( | 'down') : KneelOnAction
    verbPhrase = 'kneel/kneeling (on what)'
    askDobjResponseProd = singleNoun

    construct()
    {
        /* set up the empty direct object phrase */
        dobjMatch = new EmptyNounPhraseProd();
        dobjMatch.responseProd = onSingleNoun;
    }
;


DefineTAction(Hug);

VerbRule(Hug)
  ( 'hug' | 'embrace' ) singleDobj
  : HugAction
  verbPhrase = 'hug/hugging (what)'
;

DefineTAction(Lick);

VerbRule(Lick)
  ( 'lick' | 'suck' | 'blow' | 'eat' 'out' ) singleDobj
  : LickAction
  verbPhrase = 'lick/licking (what)'
;

/* FeelThru is a dummy verb used when feeling through clothes */
DefineTAction(FeelThru);

replace VerbRule(Kiss)
    ( 'kiss' | 'smooch' | 'snog' | 'make' 'out' 'with' ) dobjList
    : KissAction
    verbPhrase = 'kiss/kissing (what)'
;

replace VerbRule(Feel)
    ( 'feel' | 'touch' | 'rub' | 'massage' | 'pet' | 'hold' ) dobjList
    : FeelAction
    verbPhrase = 'feel/feeling (what)'
;

replace VerbRule(Screw)
    ( 'screw' | 'fuck' | 'shag' | 'make' 'love' 'to' | 'have' 'sex' 'with' | 'sleep' 'with' ) dobjList
    : ScrewAction
    verbPhrase = 'have/having sex with (what)'
;


DefineIAction(MasturbateSelf)
  execAction()
  { 
    if(gActor.defaultScrewPart) replaceAction(Feel, gActor.defaultScrewPart);
    else "You need to be more specific. ";
  }
;

VerbRule(MasturbateSelf)
  ( 'masturbate' | 'jack' 'off' )
  : MasturbateSelfAction
  verbPhrase = 'masturbate/masturbating'
;

DefineTAction(Masturbate);

VerbRule(Masturbate)
  ( 'masturbate' | 'jack' 'off' ) singleDobj
  : MasturbateAction
  verbPhrase = 'masturbate/masturbating (what)'
;



modify Thing
  dobjFor(KneelOn)
  {
    preCond = [touchObj]
    verify() { illogical(&cannotSitOnMsg); }
  }
  dobjFor(Hug)
  {
    preCond = [touchObj]
    verify() 
    {
      if(gActor == self) illogical('{You/he} can\'t hug {yourself}! ');
      else if(!ofKind(Person)) illogical('{You/he} can\'t hug
                {the dobj/him}. ');
    }
    check()
    {
      "{The dobj/he} probably wouldn\'t like that. ";
      exit;
 
    }
  }
  dobjFor(Kiss)
  {
    verify() 
    {
      if(gActor == self) illogical('{You/he} can\'t kiss {yourself}! ');
      else if(!ofKind(Person)) illogical('{You/he} can\'t kiss
                {the dobj/him}. ');
    }
    check()
    {
      "{The dobj/he} probably wouldn\'t like that. ";
      exit;
 
    }
  }
  dobjFor(Lick)
  {
    preCond = [touchObj]
    verify() 
    {
      if(!ofKind(Person)) illogical('{The dobj/him} doesn\'t look very appetizing. ');
    }
    check()
    {
      "{The dobj/he} probably wouldn\'t like that. ";
      exit;
 
    }
  }

  dobjFor(FeelThru)
  {
    check()
    {
      "ERROR!  FeelThru executed on a non-FeelPart! ";
      exit;
 
    }
  }
  dobjFor(DanceWith)
  {
    preCond = [touchObj]
    verify() 
    {
      if(!ofKind(Person)) illogical('{The dobj/him} probably wouldn\'t make a good dance partner. ');
    }
    check()
    {
      "{The dobj/he} probably wouldn\'t like that. ";
      exit;
 
    }
  }
  dobjFor(Masturbate)
  {
    check()
    {
      "{The dobj/he} probably wouldn\'t like that. ";
      exit;
 
    }
  }
;


/*** Modifications to clothing ***/

modify Layered
  private = true      /* if private, we need to check to see if wearer is willing to doff it */
  minDoffArouse = 0   /* arousal necessary before wearer will doff this */
  feelThruPart = nil /* set to a body part if you want touching clothing to result in touching that body part */
  feelThru
  {
     if(!feelThruPart) return nil;
     else if(feelThruPart.location != location) return nil;
     else return true;
  }
  hideFromAll(action)
  { 
    /* this does not work! */
    if(isWorn() && wornBy != gActor) return true;
    else return nil;
  }  

    dobjFor(Doff)
    {
        verify()
        {
          inherited();
          location.tryToPickPartner;
        }
        check()
        {
          if(blocker(location))
          {
            "{You/he} must take off <<blocker(location).theName>> before {you/he} can remove <<theName>>. ";
            exit;
          }
          else if(private)
          {
            location.checkOkay(gActor, gActor.minDoffArouse, minDoffArouse);
          }
        }
        action()
        {
            /* un-wear the item and describe what happened */
            doffMsg;
            makeWornBy(nil);
            if(!neverCover) noCover = nil;
            gActor.getDropDestination(self, nil)
                .receiveDrop(self, dropTypeDrop);
        }
    }
    dobjFor(Wear)
    {
        action()
        {
            /* make the item worn and describe what happened */
            makeWornBy(gActor);
            wearMsg;
        }
    }
    dobjFor(Feel)
    {
       check()
       {
          if(feelThru) replaceAction(Feel, feelThruPart);
       }
       
    }
;

/* Quick stripping 
* We use insta-undressing instead of sequential undressing as in layered
* Avoid using this for NPCs
*/
modify UndressImplicitAction
  replace execAction()
  { 
    if(!gActor.willUndress || !gActor.ofKind(SexPerson) )
    {
      "You need to be more specific about what {you/he} should remove. ";
      exit;
    }
    else if( gActor.listClothing.length() == 0 )
    {
      "But {you/he} {are}n't wearing anything! ";
      exit;
    }
    else
    {
      gActor.checkVoyeurs(gActor);
      gActor.undressMsg;
      gActor.quickUndress;
    }
  }
;

/*** Sex-related actors***/

/* SexPerson is the general class for actors who can engage in sexual activity */
/* Kissing is handled within SexPerson, other actions generally handled in body parts */
class SexPerson: ClothedPerson
  /* brightness set to 1 to allow sex in the dark.  This has the */
  /* unfortunate side effect of allowing NPCs to be seen in the dark. */
  /* You can deal with this by customizing the NPC's desc in a dark room. */
  brightness = 1
  /* indicator of actor's level of arousal, from 0-100.  This can be manually incremented or
  automatically set when the character enters into a new SexState. */
  arousal = 0   
  loverList = []  /* list of persons with whom actor is willing to interact sexually */
  horny = curState.horny     /* indicates whether actor is ready to engage in sexual activity.  By default, let the actor's state handle this */
  sexPartner = curState.sexPartner  /* Indicates the actor's current sex partner.  By default, let the actor's state handle this */
  setMySexPartner = nil   /* True if sexPartner needs to be set manually, usually true for player */
  postureProp  /* Describes the actor's current posture and location */
  {
    "<<posture.participle>> ";
    if(location.ofKind(NestedRoom)) "<<location.actorInName>>";
    else "here";
  }

  /* Activate the two following lines to give full description the first time the actor is encountered: */
  /*   isInInitState = true
       initSpecialDesc { specialDesc; desc; isInInitState = nil; }  */

  /* override default class-specific description to allow author to customize */
  /* description of posture, clothing, and items carried */
  examineStatus()
  {
    /* show the status from our state object */
    curState.stateDesc;
  }

  /* Include all contents in scope for dark rooms */
  getExtraScopeItems(actor) { return contents; }
  
  /* Minimum levels of arousal required for actor to do certain things */
  minKissArouse = 0
  minFeelArouse = 0
  minLickArouse = 0
  minScrewArouse = 0
  minDoffArouse = 0
  minWatchArouse = 0
  
  /* Default is strip command does not work on NPCs */
  willUndress = nil

  /* refusal messages, can be customized for each actor */
  defaultRefusal = "\"Umm, I'd rather not do that.\" "
  defaultStopit = "\"Stop it, <<gActor.name>>!\" exclaims <<theName>>. "
  defaultNothere = "\"Here?  Are you crazy?  Someone might see!\" "
  refusal = curState.refusal
  stopit = curState.stopit
  nothere = curState.nothere
  nowatch = stopit
  novoyeurs(actor) { "\"Not with <<actor.theName>> watching!\" <<theName>> protests. "; }
  noNudeTravelMsg = "\^<<theName>> really shouldn't go out in public less
                     than fully clothed! "
  defaultCommandResponse(fromActor, topic) { refusal; }
  
  /* default parts */
  defaultFeelPart = nil
  defaultLickPart = nil    /* usually set this to genitals */
  defaultScrewPart = nil   /* usually set this to genitals */
  

  /* The arouse function increments arousal and advances to a new state if appropriate */
  arouse(num)
  {
    arousal += num;
    if(curState && arousal >= curState.maxArousal ) 
    {
      arousal = curState.maxArousal;
      if(curState.nextArousalState) setCurState(curState.nextArousalState);
    }
  }
  
  /* The orgasm function can be used e.g. to reset arousal after orgasm, default is to do nothing */
  orgasm {}  
 
  /* Disambiguation routine tries to pick the actor's partner when possible */
  tryToPickPartner
  {
    if(gActor.sexPartner == self) logicalRank(150, 'partner');
  }

  loves(actor)
  {
    if(isMemberOfList(actor, loverList)) return true;
    else return nil;
  }

  /* general check of willingness to engage in sexual activity */
  checkOkay(actor, aarouse, sarouse)    
  {
    if(!actor.loves(self))
      { actor.refusal; exit; }
    else if(!actor.horny)
      { actor.refusal; exit; }
    else if(!location.isPrivate)
      { actor.nothere; exit; }
    else if(actor.arousal < aarouse)
      { actor.refusal; exit; }
    else if(!loves(actor))
      { stopit; exit; }
    else if(!horny)
      { stopit; exit; }
    else if(arousal < sarouse)
      { stopit; exit; }
      
  /* check to see if any unwanted person is watching */
    actor.checkVoyeurs(self);
    self.checkVoyeurs(actor);
  }
  /* looks around to see if any unwanted person is watching */
  checkVoyeurs(actor)
  {
    foreach(local cur in sensePresenceList(sight))
    {
      if(cur != self && cur != actor && cur.ofKind(Person) && 
      (!cur.loves(self) || !cur.horny || cur.arousal < cur.minWatchArouse) && canBeSeenBy(cur))
      {
        if(cur.ofKind(SexPerson)) cur.nowatch;
        else novoyeurs(cur);
        exit;
      }
    }
  }

   /* verb handling--all but kiss and hug are generally handled through body parts */

    hugMsg = curState.hugMsg
    defaultHugMsg = "{You/he} hug{s} <<theName>>. "
    willHug(actor) { return loves(actor); }
    dobjFor(Hug)
    {
      check()
      {
        if(!gActor.willHug(self)) { gActor.refusal;  exit; }
        else if(!willHug(gActor)) { stopit; exit; }
      }
      action()
      {
        hugMsg;
      }
    }
  
    dobjFor(Kiss)
    {
       verify()
       {

          if(gActor == self) illogicalSelf('{You/he} can\'t kiss {yourself}! ');
          else if(!ofKind(Person)) illogical('{You/he} can\'t kiss
                {the dobj/him}. ');
          else tryToPickPartner;
       }
       check()
       {
         checkOkay(gActor, gActor.minKissArouse, minKissArouse);
       }
        action()
        {
            /* note that the issuer is targeting us with conversation */
            gActor.noteConversation(self);

            /* let the state object handle it */
            curState.handleConversation(gActor, kissTopicObj, kissConvType);
        }
    }
   dobjFor(Feel)
   {
     verify() {}
     check()
     {
       if(!defaultFeelPart)
       {
         "You need to be more specific. ";
         exit;
       }
       else replaceAction(Feel, defaultFeelPart);
     }
   }
   dobjFor(Lick)
   {
     verify() {}
     check()
     {
       if(!defaultLickPart)
       {
         "You need to be more specific. ";
         exit;
       }
       else replaceAction(Lick, defaultLickPart);
     }
   }
   dobjFor(Eat) asDobjFor(Lick)
   dobjFor(Screw)
   {
     verify() {}
     check()
     {
       if(!defaultScrewPart)
       {
         "You need to be more specific. ";
         exit;
       }
       else replaceAction(Screw, defaultScrewPart);
     }
   }
   dobjFor(Enter) asDobjFor(Screw)
   dobjFor(Masturbate)
   {
     verify() {}
     check()
     {
       if(!defaultScrewPart)
       {
         "You need to be more specific. ";
         exit;
       }
       else replaceAction(Feel, defaultScrewPart);
     }
   }
   
   /* Make sure person does not enter public area while naked */
   /* Feel free to customize fitForPublic for individual NPCs */
   fitForPublic
   {
     /* If actor has a clothing list, must be fully clothed */
     if(clothingList.length() > 0)
     {
       foreach(local cur in clothingList)
       {
         if(!cur.isWornBy(self)) return nil;
       }
       return true;
     } 
     /* Otherwise check private parts */
     else if(defaultScrewPart)
     {
       if(!defaultScrewPart.cover) return nil;
       else return true;
     }
     else return true;
   }
   canTravelVia(connector, dest)
   {
     if(dest && !dest.isPrivate && !fitForPublic) return nil;
     else return inherited(connector, dest); 
   }
   explainNoTravelVia(connector, dest)
   {
     if(dest && !dest.isPrivate && !fitForPublic) noNudeTravelMsg;
     else inherited(connector, dest);

   }
;

/* A class representing non-sexual NPCs */
class NoSexPerson:  Person
  /* override default class-specific description to allow author to customize */
  /* description of posture, clothing, and items carried */
  examineStatus()
  {
    /* show the status from our state object */
    curState.stateDesc;
  }
    noSexMsg = "You aren't really interested in doing that. "
    dobjFor(Hug)
    {
       check()
       {
        if(!willHug(gActor) )
          { noSexMsg; exit; }
       }
    }
    dobjFor(Kiss)
    {
       check()
       {
         noSexMsg; exit;
       }
    }
    dobjFor(Feel)
    {
       check()
       {
         noSexMsg; exit;
       }
    }
    dobjFor(Eat) asDobjFor(Lick)
    dobjFor(Lick)
    {
       check()
       {
         noSexMsg; exit;
       }
    }
    dobjFor(Screw)
    {
       verify() {}
       check()
       {
         noSexMsg; exit;
       }
    }
    dobjFor(ScrewWith)
    {
       check()
       {
         noSexMsg; exit;
       }
    }
;

/* A class representing the player */
class SexPlayer:  SexPerson
  defaultRefusal = "You aren't interested in doing that. "
  defaultStopit = "You aren't interested in that. "
  refusal = curState.refusal
  stopit = curState.stopit
  nothere = "This probably isn't a good place for that. "
  novoyeurs(actor) { "You don't feel comfortable doing that with <<actor.theName>> watching. "; }
  defaultHugMsg = "\^<<gActor.theName>> gives you a hug. "
  horny = true  /* player is always horny */
  willUndress = true  // Player can strip
  willHug(actor) { return true; } /* will hug anyone */
  minKissArouse = 0
  checkTakeFromInventory(actor, obj) {}  /* player will freely give items to NPCs */
  setMySexPartner = true   /* Need to set player's sex partner manually */
  
  /* Remap all kissing interactions to the NPC's conversation topics */
  dobjFor(Kiss)
  {
    action()
    {
        /* note that we are targeting the NPC with conversation */
        noteConversation(gActor);
         /* let the state object handle it */
        gActor.curState.handleConversation(gActor, kissPlayerTopicObj, kissPlayerConvType);
    }
  }
;

/* The Possession class automatically alters the description of an owned */
/* object depending on who is acting on it.  This avoids messages like */
/* "Jane feels Jane's tits" by changing it to "Jane feels her tits." */
class Possession: Thing
   theName
   {
     if(!owner) return inherited();
     if(owner == gPlayerChar || owner == gActor) return owner.itPossAdj + ' ' + name;
     else return theNameWithOwner(); 
   }
   owner = location      // default owner is object's location
;

/*** Body parts ***/

/* BodyParts are where most sex actions are handled */
class BodyPart: Possession, BodyArea, Component
   owner = location
   selfLick = nil   /* default is can't be licked by owner */
   lickThru = nil   /* default is can't be licked through clothing */
   feelThru = true  /* default is can be felt through clothing */
   senseUnderClothes(sense) { return true; }  /* default is body parts can be sensed even under opaque clothes */
   hideFromAll(action) { return true; }  /* Don't include body parts in ALL */
   dobjFor(Feel)
   {
     verify()
     {
       if(cover && !feelThru) inaccessible ( '{You/he} cannot feel {that dobj/him} through clothing! ' );
       else location.tryToPickPartner;
     }
     check()
     {
       "\^<<location.theName>> probably wouldn't take kindly to your touching {that dobj/him}. ";
       exit;
     }

   }
   dobjFor(Lick)
   {
     verify()
     {
       if(gActor == location && !selfLick) illogicalSelf( '{You/he} cannot have sex with {yourself}! ' );
       else if(cover && !lickThru) inaccessible( '{You/he} cannot lick {that dobj/him} through clothing! ' );
       else location.tryToPickPartner;
     }
     check()
     {
       "{The dobj/him} do{es}n't look very appetizing. ";
       exit;
     }

   }
   dobjFor(Kiss) asDobjFor(Lick)
   dobjFor(Eat) asDobjFor(Lick)
   dobjFor(Screw)
   {
     verify()
     {
       if(gActor == location) illogicalSelf( '{You/he} cannot have sex with {yourself}! ' );
       else if(cover) inaccessible ( '{You/he} cannot have sex through clothing! ' );
       else illogical ( 'I\'m not sure how {you/he} plan{s} to do that. ' );
     }

   }

   iobjFor(ScrewWith)
   {
     verify()
     {
       illogical( 'I don\'t understand what you\'re trying to do. ' );
     }
   }
   dobjFor(Masturbate) asDobjFor(Feel)
;

class FeelPart: BodyPart
  feelThru = true      /*default is we can feel this through clothes */
  minFeelArouse = 0
  dobjFor(Feel)
  {
     check()
     {
       location.checkOkay(gActor, gActor.minFeelArouse, minFeelArouse);
       if(cover)
       {
         if(!feelThru)
         {
           "{You/he} can't really feel that with <<cover.theName>> in the way. ";
           exit;
         }
         else replaceAction(FeelThru, self);
       }
     }
     action()
     {
            
            /* note that the issuer is targeting us with conversation */
            gActor.noteConversation(location);

            /* let the state object handle it */
            location.curState.handleConversation(gActor, self, feelConvType);
     }
  }
  dobjFor(FeelThru)
  {
     check()
     {
       if(!cover) { "Error!  Tried to FeelThru an uncovered body part! "; exit; }
     }
     action()
     {
            
            /* note that the issuer is targeting us with conversation */
            gActor.noteConversation(location);

            /* let the state object handle it */
            location.curState.handleConversation(gActor, self, feelThruConvType);
     }
  }
;

class LickPart: BodyPart
  minLickArouse = 0
  dobjFor(Lick)
  {
     check()
     {
       location.checkOkay(gActor, gActor.minLickArouse, minLickArouse);
     }
     action()
     {
            
            /* note that the issuer is targeting us with conversation */
            gActor.noteConversation(location);

            /* let the state object handle it */
            location.curState.handleConversation(gActor, self, lickConvType);
     }

  }
;


class ScrewPart: BodyPart
  minScrewArouse = 0
  dobjFor(Screw)
  {
     verify()
     {
       local io = gActor.defaultScrewPart;
       if(gActor == location) illogicalSelf( '{You/he} cannot have sex with {yourself}! ' );
       else if(cover) inaccessible ( '{You/he} cannot have sex through clothing! ' );
       else if(!io) illogical('With what? ');
       else if(!io.ofKind(ScrewerPart)) illogical('With what? ');
       else if(io.cover) inaccessible ( '{You/he} cannot have sex through clothing! ' );
       else if(isDildo && !io.isOrifice) 
         illogical( 'I don\'t understand what you\'re trying to do. ' );
       else if(isOrifice && !io.isDildo) 
         illogical( 'I don\'t understand what you\'re trying to do. ' );
       else location.tryToPickPartner;
     }
     check()
     {
       location.checkOkay(gActor, gActor.minScrewArouse, minScrewArouse);
     }
     action()
     {
            
            /* note that the issuer is targeting us with conversation */
            gActor.noteConversation(location);

            /* let the state object handle it */
            location.curState.handleConversation(gActor, self, screwConvType);
     }
  }
;

class ScrewerPart: BodyPart
  isDildo = nil
  isOrifice = nil    /* must set one of these two to true */

;



class ErectPart: BodyPart
  erectArouse = 1
  isErect
  {
    if(location.arousal >= erectArouse) return true;
    else return nil;
  }
;

class Orifice:  RestrictedContainer
  isOrifice = true

;

class Dildo: Thing
  isDildo = true
  bulk = 1

;

/* various body parts */

class VaginaPart: Orifice, ScrewerPart, ScrewPart, FeelPart, LickPart, crotchArea
  vocabWords = 'vagina/pussy/cunt/clit/clitoris'
  name = 'pussy'
;

class PenisPart: ErectPart, ScrewerPart, ScrewPart, FeelPart, LickPart, crotchArea
  vocabWords = 'penis/dick/cock'
  name = 'penis'
  isDildo = true
;

class BreastPart: ErectPart, ScrewPart, FeelPart, LickPart, chestArea
  vocabWords = 'breast/breasts/tit/tits/nipple/nipples/boob/boobs/chest/cleavage'
  name = 'tits'
  isPlural = true
  isOrifice = true
  isScrewable = true /* default is breasts are large enough for sex */
  tooSmallMsg = "Alas, <<theName>> are too small for that. "
  dobjFor(Screw)
  {
    check()
    {
      if(isScrewable) inherited();
      else
      {
        tooSmallMsg;
        exit;
      }
    }
  }
;

class AssPart: Orifice, ScrewPart, FeelPart, crotchArea
  vocabWords = 'ass/arse/butt/bum/rear'
  name = 'ass' 
  isScrewable = nil /* default is no anal sex */
  dobjFor(Screw)
  {
    check()
    {
      if(isScrewable) inherited();
      else
      {
        location.stopit;
        exit;
      }
    }
  }

;

class LegsPart: FeelPart, legsArea
  vocabWords = 'leg/legs/thigh/thighs'
  name = 'legs'
  isPlural = true
;

class HairPart: FeelPart, headArea
  vocabWords = 'hair'
  name = 'hair'
  feelThru = nil
;

class MouthPart: ScrewPart, mouthArea
  vocabWords = 'mouth/lips'
  name = 'mouth'
  isOrifice = true 
  dobjFor(Kiss) remapTo(Kiss, location)
  dobjFor(Screw)
  {
     check()
     {
       replaceActorAction(location, Lick, gActor.defaultScrewPart);
     }
  }
;

class EyesPart: BodyPart, eyesArea
  vocabWords = 'eye/eyes'
  name = 'eyes'
;

class BackPart: FeelPart, backArea
  vocabWords = 'back/shoulder/shoulders'
  name = 'back'
;

class ChestPart: FeelPart, chestArea
  vocabWords = 'chest'
  name = 'chest'
;

class HandsPart: FeelPart, handsArea
  vocabWords = 'hand/hands/finger/fingers'
  name = 'hand'
;

class FeetPart: FeelPart, feetArea
  vocabWords = 'foot/feet/toe/toes'
  name = 'feet'
;

/* PlayerPart add-in class to be used for the player's bodyparts
*  remaps all sexual interactions with an NPC to the conversation topics
*  for that NPC.
*  Note that PlayerPart must precede other BodyPart classes in the defintion, e.g.
*
*    + myPenis: PlayerPart, PenisPart
*/

class PlayerPart: BodyPart
  dobjFor(Feel)
  {
     action()
     {
            /* remap to NPC's conversation topics */
            location.noteConversation(gActor);
            gActor.curState.handleConversation(gActor, self, feelConvType);
     }
  }
  dobjFor(FeelThru)
  {
     action()
     {
            /* remap to NPC's conversation topics */
            location.noteConversation(gActor);
            gActor.curState.handleConversation(gActor, self, feelThruConvType);
     }
  }
  dobjFor(Lick)
  {
     action()
     {
            /* remap to NPC's conversation topics */
            location.noteConversation(gActor);
            gActor.curState.handleConversation(gActor, self, lickConvType);
     }
  }
  dobjFor(Screw)
  {
     action()
     {
            /* remap to NPC's conversation topics */
            location.noteConversation(gActor);
            gActor.curState.handleConversation(gActor, self, screwConvType);
     }
  }
;


/*** Sex topics ***/

/* Sex is handled in same way as a conversation */
/* handling of Kiss based on TalkTo */
/* handling of Feel, Lick, and Screw based on Give */



/* New types of topics for sexual interactions */

modify ActorTopicDatabase
  kissTopics = nil
  lickTopics = nil
  feelTopics = nil
  feelThruTopics = nil
  screwTopics = nil
  kissPlayerTopics = nil
;

/* Topics for use when the player is acting on the responding NPC */

class KissTopic: MiscTopic
    includeInList = [&kissTopics]
     matchList = [kissTopicObj]
;

kissTopicObj: object
;


class FeelTopic: ThingMatchTopic
    includeInList = [&feelTopics]
;

class FeelThruTopic: ThingMatchTopic
    includeInList = [&feelThruTopics]
;

class LickTopic: ThingMatchTopic
    includeInList = [&lickTopics]
;

class ScrewTopic: ThingMatchTopic
    includeInList = [&screwTopics]
;


class DefaultKissTopic: DefaultTopic
    includeInList = [&kissTopics]
    matchScore = 3
;


kissConvType: ConvType
    topicListProp = &kissTopics
    defaultResponseProp = &defaultKissResponse
    defaultResponse(db, other, topic)
        { db.defaultKissResponse(other, topic); }
;

feelConvType: ConvType
    topicListProp = &feelTopics
    defaultResponseProp = &defaultFeelResponse
    defaultResponse(db, other, topic)
        { db.defaultFeelResponse(other, topic); }
;

feelThruConvType: ConvType
    topicListProp = &feelThruTopics
    defaultResponseProp = &defaultFeelThruResponse
    defaultResponse(db, other, topic)
        { db.defaultFeelThruResponse(other, topic); }
;

lickConvType: ConvType
    topicListProp = &lickTopics
    defaultResponseProp = &defaultLickResponse
    defaultResponse(db, other, topic)
        { db.defaultLickResponse(other, topic); }
;

screwConvType: ConvType
    topicListProp = &screwTopics
    defaultResponseProp = &defaultScrewResponse
    defaultResponse(db, other, topic)
        { db.defaultFeelResponse(other, topic); }
;

/* Topics for use when an NPC is acting on the player */

class KissPlayerTopic: MiscTopic
    includeInList = [&kissPlayerTopics]
     matchList = [kissPlayerTopicObj]
;

kissPlayerTopicObj: object
;


kissPlayerConvType: ConvType
    topicListProp = &kissPlayerTopics
    defaultResponseProp = &defaultKissPlayerResponse
    defaultResponse(db, other, topic)
        { db.defaultKissPlayerResponse(other, topic); }
;


/* An AltWhoTopic is a topic that is only active when a specified actor
*  (usually someone other than the player) is the one acting
*/

class AltWhoTopic: AltTopic
    actor = nil
	isActive
	{ 
	  if(!actor) return true;
	  else if(gActor == actor) return true;
	  else return nil;
	}
;

AltWhoTopic template ->actor "topicResponse" | [eventList];

/*** Sex States ***/

modify ActorState
   horny = nil    /* Default is NPC not ready for sex */
   arousal = 0    /* Default is NPC is not aroused */
   sexPartner = getActor()  /* Define current partner to be self */
   maxArousal = 100   /* Maximum level of arousal possible in this state */
   nextArousalState = nil   /* Can advance to a new state if arousal exceeds maxArousal */
   refusal = getActor().defaultRefusal
   stopit = getActor().defaultStopit
   nothere = getActor().defaultNothere
   
   hugMsg = getActor().defaultHugMsg
   
  /* Messages for NPC acting on player; used by templates */
  /* These are no longer being used */
  /*
  hugPlayerMsg = getActor().defaultHugPlayerMsg
  kissPlayerMsg = getActor().defaultKissPlayerMsg
  feelPlayerMsg = getActor().defaultFeelPlayerMsg
  feelThruPlayerMsg = getActor().defaultFeelThruPlayerMsg
  lickPlayerMsg = getActor().defaultLickPlayerMsg
  screwPlayerMsg = getActor().defaultScrewPlayerMsg
  screwPlayerWithMsg = getActor().defaultScrewPlayerWithMsg

  feelTitsMsg = getActor().defaultFeelTitsMsg
  feelThruTitsMsg = getActor().defaultFeelThruTitsMsg
  lickTitsmsg = getActor().defaultLickTitsmsg
  screwTitsMsg = getActor().defaultScrewTitsMsg
  */
;

/* New reasons for ending sexual "conversation" */
enum endConvPartner;
enum endConvPosition;

/* SexState is the base class for all sex-related states */
class SexState: ActorState
   /* descriptions should be customized */
   horny = true
   arousal = 0  /* Default level of arousal */
   sexPartner = gPlayerChar  /* Default sex partner is player */
   specialDesc()
   {
     "\^<<getActor.theName>> <<getActor.verbToBe>> <<getActor.postureProp>>. ";
   }
   stateDesc
   {
     "\^<<getActor.itIs>> <<getActor.postureProp>>. ";
   }

   obeyCommand(issuer, action)
   {
     if(isMemberOfList(action.baseActionClass, verbList)) return true;
     else return inherited(issuer, action);
   }
   /* list of command actor will accept in this state */
   verbList = [HugAction, KissAction, FeelAction, LickAction,
               ScrewAction,
               DoffAction, RemoveAction, WearAction, TakeAction, DropAction,
               LieOnAction, SitOnAction, StandOnAction, KneelOnAction, StandAction,
               BoardAction, GetOffOfAction, GetOutOfAction, 
               DressAction, UndressAction]
   /* actor will freely allow player to take items */
   checkTakeFromInventory(actor, obj) {}
   activateState(actor, oldState)
   {
     if(arousal > getActor().arousal) getActor().arousal = arousal;
     if(sexPartner.setMySexPartner) sexPartner.sexPartner = getActor();
     inherited(actor, oldState);
   }
;

/* InSexState is a combination of SexState and InConversationState */
/* Use if state should terminate when actor leaves */
class InSexState: SexState, InConversationState
   attentionSpan = nil  /* default is infinite attention span */
   activateState(actor, oldState)
   {
     if(arousal > getActor().arousal) getActor().arousal = arousal;
     if(sexPartner.setMySexPartner) sexPartner.sexPartner = getActor();
     if (previousState == nil || oldState.ofKind(ConversationReadyState))
            previousState = oldState;
     actor.boredomCount = 0;
     actor.addToAgenda(actor.boredomAgendaItem);
     actor.lastConvTime = Schedulable.gameClockTime;
     inherited(actor, oldState);
   }
;

/* SexReadyState is a combination of SexState and ConversationReadyState */
class SexReadyState: SexState, ConversationReadyState
   verbList = []  //default is for NPC to obey no commands
;

/* A state representing a sex position, with set locations and postures
   for the participants.  The state automatically terminates if either
   party moves out of the defined position */
class SexPositionState: InSexState
   /* default is no fixed location or posture */
   actorLocation = nil
   actorPosture = nil
   partnerLocation = nil
   partnerPosture = nil
   activateMessage {}
   activateState(actor, oldState)
   {
      local p = sexPartner;
      if(!p) { "ERROR! No sex partner!"; exit; }
      if(actorLocation && actor.location != actorLocation) actor.moveIntoForTravel(actorLocation);
      if(actorPosture && actor.posture != actorPosture) actor.posture = actorPosture;
      if(partnerLocation && p.location != partnerLocation) p.moveIntoForTravel(partnerLocation);
      if(partnerPosture && p.posture != partnerPosture) p.posture = partnerPosture;
      activateMessage;
      inherited(actor, oldState);
   }

   /* Check to see if still in position */
    afterAction()
    {
        local g = getActor();
        local p = sexPartner;
        if(g.curState != self) exit;
        else if((actorPosture && g.posture != actorPosture)
               || (partnerPosture && p.posture != partnerPosture)
               || (actorLocation && g.location != actorLocation)
               || (partnerLocation && p.location != partnerLocation))
        {
           endConversation(gActor, endConvPosition);
        }
        inherited();
    }
;

/* Alternatively, sex positions can be handled using conversation nodes */
class SexPositionNode: ConvNode 
   actorLocation = nil
   actorPosture = nil
   partnerLocation = nil
   partnerPosture = nil
   activateMessage {}
   noteActive()
   {
      local actor = getActor();
      local p = getActor().sexPartner;
      if(!p) { "ERROR! No sex partner!"; exit; }
      if(actorLocation && actor.location != actorLocation) actor.moveIntoForTravel(actorLocation);
      if(actorPosture && actor.posture != actorPosture) actor.posture = actorPosture;
      if(partnerLocation && p.location != partnerLocation) p.moveIntoForTravel(partnerLocation);
      if(partnerPosture && p.posture != partnerPosture) p.posture = partnerPosture;
      activateMessage;
   }
;

/* Special SexState for the player */
/* Default assumption is that player is always in his */
/* PlayerSexState, so no need to move to a new state */
class PlayerSexState: SexState
    horny = true
    arousal = 100    /* Player is always horny and aroused */
    stateDesc = ""
    specialDesc() {}
;


/* A state in which the character greets the player when he enters the area */
/* (Might be better just to use an agenda item for this?) */
class WelcomeState: ActorState
  welcomed = nil
  firstWelcome = nil
  firstWelcomeMsg { welcomeMsg; }
  welcomeMsg
  {
    showGreetingMsg(gPlayerChar, nil);
  }
  takeTurn()
  {
    if(getActor.canBeSeen)
    {
      if(getActor.canTalkTo(gPlayerChar) && !welcomed)
      {
        if(firstWelcome) firstWelcomeMsg;
        else welcomeMsg;
        welcomed = true;
        firstWelcome = nil;
      }
    }
    else welcomed = nil;
    inherited();
  }
;

/*** Agenda items ***/

/* State agenda items can be located within states and are active whenever the actor is in that state */
class StateAgendaItem: AgendaItem
  getActor()
  {
     if (location.ofKind(ActorState))
       return location.getActor();
     else
       return location;
  }
  initiallyActive = true
  isReady   /* check to see whether the actor is in the applicable state */
  {
    if((location != getActor().curState) && (location != getActor())) return nil;
    else return inherited();
  }
;

/* Note--be careful about mixing StateAgendaItems and SexAgendaItems in the same state.  A
*  conversation will postpone only the SexAgendaItems, which can result in the
*  StateAgendaItems being executed out of order.
*/

/* SexAgendaItem is a combination of StateAgendaItem and ConvAgendaItem. It is executed only when
*  with partner and no activity in the preceding turn */
class SexAgendaItem: StateAgendaItem
  isReady = (!getActor().conversedThisTurn()
               && getActor().canTalkTo(otherActor)
               && inherited())
  otherActor = getActor().sexPartner
;

/* Arouse Agenda Item will be performed when the actor's arousal is high enough */
class ArouseAgendaItem: SexAgendaItem
  arousal = 0
  isReady
  {
    if(getActor().arousal < arousal) return nil;
    else return inherited();
  }
;

ArouseAgendaItem template +arousal;

/* DoffAgendaItem makes the NPC attempt to take off a piece of clothing */
class DoffAgendaItem: ArouseAgendaItem
  garment = nil   /* Set this to a piece of clothing that the NPC will try to doff */
  arousal = garment.minDoffArouse
  noRepeat = true   /* If true, the NPC will only remove this once */
  isReady   /* check to see whether the item is doffable */
  {
    if(getActor().arousal < arousal) return nil;
    else if(!garment.isWorn) return nil;
    else if(garment.blocker(garment.location)) return nil;
    else if(getActor().arousal < garment.minDoffArouse) return nil;
    else return inherited();

  }
  invokeItem
  {
     nestedActorAction(getActor(), Doff, garment);
     if(noRepeat) isDone = true;
  }
;

DoffAgendaItem template +arousal? @garment;


/* A WelcomeAgendaItem plays a welcome message when the player enters the room */
class WelcomeAgendaItem: StateAgendaItem
  agendaOrder = 10 // Execute this before other agenda items
  welcomed = nil
  welcomeMsg
  {
    showGreetingMsg(gPlayerChar, nil);
  }
  isReady
  {
    if(!inherited()) return nil;
    else if(getActor().canBeSeen && getActor().canTalkTo(gPlayerChar) && !welcomed) return true;
    else if(!getActor().canBeSeen && welcomed) return true;
    else return nil;
  }
  invokeItem
  {
    if(getActor().canBeSeen)
    {
	  welcomeMsg;
      welcomed = true;
    }
    else welcomed = nil;
  }
;

WelcomeAgendaItem template "welcomeMsg";

/*** New tags that can be used in sex scenes ***/
/*
*  <.arouse [number]> calls respondingActor.arouse([number])
*  <.orgasm> calls respondingActor.orgasm
*/

/* The following gigantic piece of code simply adds the "arouse" and "orgasm" tags
to the list of tags that can be
included in conversation text */
modify conversationManager
    customTags = 'arouse'
    filterText(ostr, txt)
    {
        local start;
        
        /* scan for our special tags */
        for (start = 1 ; ; )
        {
            local match;
            local arg;
            local actor;
            local sp;
            local tag;
            
            /* scan for the next tag */
            match = rexSearch(tagPat, txt, start);

            /* if we didn't find it, we're done */
            if (match == nil)
                break;

            /* get the argument (the third group from the match) */
            arg = rexGroup(3);
            if (arg != nil)
                arg = arg[3];

            /* pick out the tag */
            tag = rexGroup(1)[3].toLower();

            /* check which tag we have */
            switch (tag)
            {
            case 'arouse':
                if (respondingActor != nil)
                    respondingActor.arouse(toInteger(arg));
                break;
            case 'orgasm':
                if (respondingActor != nil)
                    respondingActor.orgasm;
                break;
            case 'reveal':
                /* reveal the key by adding it to our database */
                revealedNameTab[arg] = true;
                break;

            case 'convbegin':
                /* 
                 *   Internal tag - starting a conversational response for
                 *   an actor, identified by an index in our idToActor
                 *   vector.  Get the actor.  
                 */
                actor = idToActor[toInteger(arg)];

                /* 
                 *   since we're just starting a response, clear the flag
                 *   in the actor indicating that a ConvNode has been set
                 *   in the course of this response 
                 */
                actor.responseSetConvNode = nil;

                /* remember the new responding actor */
                respondingActor = actor;

                /* done */
                break;

            case 'convend':
                /*
                 *   Ending a conversational response for a given actor,
                 *   identified by the first argument, which is an index in
                 *   our idToActor vector. 
                 */
                sp = arg.find(' ');
                actor = idToActor[toInteger(arg.substr(1, sp - 1))];

                /* the rest of the argument is the default new ConvNode */
                arg = arg.substr(sp + 1);

                /* if the new ConvNode is empty, it means no ConvNode */
                if (arg == '')
                    arg = nil;

                /* 
                 *   if we didn't explicitly set a new ConvNode in the
                 *   course of this response, apply the default 
                 */
                if (!actor.responseSetConvNode)
                    actor.setConvNode(arg);

                /*
                 *   Since we've just finished showing a message that
                 *   specifically refers to this actor, the player should
                 *   be able to refer to this actor using a pronoun on the
                 *   next command.  Set the responding actor as the
                 *   antecedent for the appropriate singular pronouns for
                 *   the player character.  Note that we do this at the end
                 *   of the response, so that the antecedent is the last
                 *   one if we have more than one.  
                 */
                gPlayerChar.setPronounObj(actor);

                /* done */
                break;

            case 'convnode':
                /* 
                 *   if there's a current responding actor, set its current
                 *   conversation node 
                 */
                if (respondingActor != nil)
                    respondingActor.setConvNode(arg);
                break;

            case 'convstay':
                /* 
                 *   leave the responding actor in the old conversation
                 *   node - we don't need to change the ConvNode, but we do
                 *   need to note that we've explicitly set it 
                 */
                if (respondingActor != nil)
                    respondingActor.responseSetConvNode = true;
                break;

            case 'topics':
                /* schedule a topic inventory listing */
                scheduleTopicInventory();
                break;

            default:
                /* check for an extended tag */
                doCustomTag(tag, arg);
                break;
            }

            /* continue the search after this match */
            start = match[1] + match[2];
        }

        /* 
         *   remove the tags from the text by replacing every occurrence
         *   with an empty string, and return the result 
         */
        return rexReplace(tagPat, txt, '', ReplaceAll);
    }
;